package ru.dbotthepony.kstarbound.client.gl

import org.lwjgl.opengl.GL46.*
import ru.dbotthepony.kstarbound.client.StarboundClient

class VertexArrayObject : GLObject() {
	override val client = StarboundClient.current()
	override val pointer = glGenVertexArrays()

	init {
		checkForGLError()
		client.registerCleanable(this, ::glDeleteVertexArrays, pointer)
	}

	override fun bind() {
		client.vao = this
	}

	override fun unbind() {
		if (client.vao == this)
			client.vao = null
	}

	fun attribute(position: Int, size: Int, type: Int, normalize: Boolean, stride: Int, offset: Long = 0L): VertexArrayObject {
		client.ensureSameThread()
		glVertexAttribPointer(position, size, type, normalize, stride, offset)
		checkForGLError()
		return this
	}

	fun enableAttribute(position: Int): VertexArrayObject {
		client.ensureSameThread()
		glEnableVertexArrayAttrib(pointer, position)
		//glEnableVertexAttribArray(position)
		checkForGLError()
		return this
	}
}
